﻿using FLY.FeedbackRenZiJia.Common;
using FLY.FeedbackRenZiJia.IService;
using FLY.FeedbackRenZiJia.OBJ_INTERFACE;
using FObjBase;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace FLY.FeedbackRenZiJia.Client
{
    public class SnapShotBufServiceClient: FObjServiceClient, ISnapShotBufService
    {


        public SnapShotBufServiceClient(UInt32 serviceId) : base(serviceId) { }
        public SnapShotBufServiceClient(UInt32 serviceId, string connName) : base(serviceId, connName) { }


        #region IFObj
        public override void ConnectNotify(IFConn from)
        {
            base.ConnectNotify(from);
            if (from.IsConnected)
            {


            }
        }
        
        public override void PushCallFunction(IFConn from, uint srcid, uint magic, ushort funcid, byte[] retdata, object AsyncDelegate, object AsyncState)
        {
            switch (funcid)
            {
                case SNAPSHOT_OBJ_INTERFACE.CALL_GET_SNAPSHOT:
                    {
                        string json = Misc.Converter.BytesToString(retdata);
                        var p = Newtonsoft.Json.JsonConvert.DeserializeObject<FlyData_SnapShot>(json);

                        ((AsyncCBHandler)AsyncDelegate)(AsyncState, p);
                        
                    }
                    break;
                /// <summary>
                /// request:null
                /// reponse:Pack_IntList
                /// </summary>
                case SNAPSHOT_OBJ_INTERFACE.CALL_GET_SNAPSHOT_LIST:
                    {
                        string json = Misc.Converter.BytesToString(retdata);
                        var p = Newtonsoft.Json.JsonConvert.DeserializeObject<List<int>>(json);

                        ((AsyncCBHandler)AsyncDelegate)(AsyncState, p);
                    }
                    break;
            }
        }


        #endregion



        #region 快照
        /// <summary>
        /// 获取快照 返回类型为 FlyData_SnapShot
        /// </summary>
        /// <param name="bookmark">记录点</param>
        /// <param name="AsyncDelegate"></param>
        /// <param name="AsyncState"></param>
        public void Get(int bookmark, AsyncCBHandler AsyncDelegate, object AsyncState)
        {
            string json = Newtonsoft.Json.JsonConvert.SerializeObject(bookmark);

            FObjSys.Current.CallFunctionEx(
               mConn, mServerID, ID,
               SNAPSHOT_OBJ_INTERFACE.CALL_GET_SNAPSHOT,
                     Misc.Converter.StringToBytes(json),
                     AsyncDelegate, AsyncState);
        }
        /// <summary>
        /// 设置快照 
        /// </summary>
        /// <param name="f">FlyData_SnapShot</param>
        public void Set(FlyData_SnapShot p)
        {
            string json = Newtonsoft.Json.JsonConvert.SerializeObject(p);

            FObjSys.Current.CallFunctionEx(
               mConn, mServerID, ID,
               SNAPSHOT_OBJ_INTERFACE.CALL_SET_SNAPSHOT,
                     Misc.Converter.StringToBytes(json));
        }
        /// <summary>
        /// 删除快照
        /// </summary>
        /// <param name="bookmark"></param>
        public void Del(int bookmark)
        {
            string json = Newtonsoft.Json.JsonConvert.SerializeObject(bookmark);

            FObjSys.Current.CallFunctionEx(
               mConn, mServerID, ID,
               SNAPSHOT_OBJ_INTERFACE.CALL_DEL_SNAPSHOT,
               Misc.Converter.StringToBytes(json));
        }

        /// <summary>
        /// 获取保存的快照列表 返回类型为 List&lt;int&gt;
        /// </summary>
        /// <param name="AsyncDelegate"></param>
        /// <param name="AsyncState"></param>
        public void GetList(AsyncCBHandler AsyncDelegate, object AsyncState)
        {
            FObjSys.Current.CallFunctionEx(
               mConn, mServerID, ID,
               SNAPSHOT_OBJ_INTERFACE.CALL_GET_SNAPSHOT_LIST,
               null,
               AsyncDelegate, AsyncState);
        }
        #endregion
    }
}
