﻿using FLY.IBC.IService;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Windows.Threading;
using Unity;

namespace FLY.IBC.UI.Client
{
    /// <summary>
    /// Page_System.xaml 的交互逻辑
    /// </summary>
    public partial class PgSystem : Page
    {
        IIbcSystemService iBCSystemClient;
        FLY.OBJComponents.Client.SetPLCUpdatePlan setPlan;
        public PgSystem()
        {
            InitializeComponent();
        }

        [InjectionMethod]
        public void Init(
             IUnityContainer container,
             IIbcSystemService iBCSystemService)

        {
            this.iBCSystemClient = iBCSystemService;
            grid_ibc.DataContext = iBCSystemClient.Item;

            //注册属性更新计划
            setPlan = new FLY.OBJComponents.Client.SetPLCUpdatePlan(
                iBCSystemClient.PLCos,
                iBCSystemClient.Item,
                new string[] {
                    "SampleInterval",
                    "Area1Set",
                    "Area1P",
                    "Area1I",
                    "Area1D",
                    "Area1DI",
                    "AdjustFactor",
                    "PIDResult",
                    "PIDAdjust",
                    "InletAirVelocity",
                    "OutletAirVelocity",
                    "Area2Set",
                    "Area2P",
                    "Area2I",
                    "Area2D",
                    "Sensor1DeadZone",
                    "Sensor2DeadZone",
                    "Sensor3DeadZone",
                    "Sensor1Factor",
                    "Sensor2Factor",
                    "Sensor3Factor"
            });
        }
        

        private void Page_Unloaded(object sender, RoutedEventArgs e)
        {
            setPlan.Dispose();
        }
    }
}
