﻿using FLY.Integrated.IService;
using FLY.OBJComponents.Client;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using Unity;

namespace FLY.Integrated.UI.Client
{
    /// <summary>
    /// Window_Frequency.xaml 的交互逻辑
    /// </summary>
    public partial class WdFreq : FLY.ControlLibrary.WindowBigClose
    {
        IIntegratedSystemService integratedSystemService;
        FLY.OBJComponents.Client.SetPLCUpdatePlan setPlan;

        public WdFreq()
        {
            InitializeComponent();
            this.Closed += WdFreq_Closed;
        }

        private void WdFreq_Closed(object sender, EventArgs e)
        {
            setPlan.Dispose();
        }

        [InjectionMethod]
        public void Init(
            IIntegratedSystemService integratedSystemService
            )
        {
            this.integratedSystemService = integratedSystemService;
            this.DataContext = integratedSystemService.Accessory;
            //注册属性更新计划
            setPlan = new SetPLCUpdatePlan(
                 integratedSystemService.PLCos,
                 integratedSystemService.Accessory,
                 new string[] {
                     "RotaryFreqSet"
                 });
        }

        private void btnPlusClick(object sender, RoutedEventArgs e)
        {
            if (integratedSystemService.Accessory.RotaryFreqSet < 50.0)
                integratedSystemService.Accessory.RotaryFreqSet += 0.1f;
        }

        private void btnMinusClick(object sender, RoutedEventArgs e)
        {
            if (integratedSystemService.Accessory.RotaryFreqSet >= 0.1)
                integratedSystemService.Accessory.RotaryFreqSet -= 0.1f;
        }
    }
}
