﻿using MultiLayout.UiModule;
using System;
using System.Collections.Generic;
using System.Globalization;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Unity;

namespace FLY.HeatingHelper.UI.UiModule
{
    /// <summary>
    /// HeatThickDetector.xaml 的交互逻辑
    /// </summary>
    public partial class HeatThickDetector : Page
    {
        //ThickHeatData4SQLite_V1 _thickHeatData4SQLite_V1;
        ViewModel_HeatThickDetector vm;
        public HeatThickDetector()
        {
            InitializeComponent();
        }

        private IUnityContainer container;

        [InjectionMethod]
        public void Init(IUnityContainer container,IThickHeatData dat)
        {
            this.container = container;
            vm = new ViewModel_HeatThickDetector(container.Resolve<FLY.Thick.Blowing.IService.IBlowingService>(), dat);
            this.DataContext = vm;
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            if (!vm.HasData) return;
                NavigationService ns = Application.Current.Properties["NavigationService"] as NavigationService;
            if (ns != null)
            {
                if(vm._dat.BeginUse())
                {
                    Page_HeatDetector page = new Page_HeatDetector();
                    container.BuildUp(page);
                    ns.Navigate(page);
                }
            }
        }
    }
    public class UiModule2_HeatThickDetector : IUiModule2
    {
        #region IUIModule实现
        public string Title => "风环辅助";

        public ComponentType Type => ComponentType.DynArea;

        public bool IsUnique => true;

        public FrameworkElement GetComponent(int id,IUnityContainer container)
        {
            return container.Resolve<HeatThickDetector>();

            //HeatThickDetector fe = new HeatThickDetector();
            //IThickHeatData dat = container.Resolve<IThickHeatData>();
            //fe.Init(container, dat);
            //return fe;
        }


        public FrameworkElement GetThumbnail()
        {
            return new System.Windows.Controls.Grid();
        }

        public void MatchParam(int[] IDs)
        {
        }
        #endregion
    }
}
