﻿using FLY.OBJComponents.Client;
using FLY.OBJComponents.IService;
using FLY.Weight.Server.Model;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace FLY.Weight.Client
{
    public class MixBufferCollection
    {
        /// <summary>
        /// 服务Id
        /// </summary>
        protected UInt32 baseId;
        /// <summary>
        /// 连接名称
        /// </summary>
        public string ConnName;

        Dictionary<string, IBuffer<Lc_Mix>> buffers = new Dictionary<string, IBuffer<Lc_Mix>>();

        public MixBufferCollection(UInt32 baseId, string connName) 
        {
            this.baseId = baseId;
            ConnName = connName;
        }

        public IBuffer<Lc_Mix> GetMix(int index) 
        {
            string name = $"mix{index}";
            if (buffers.ContainsKey(name))
            {
                return buffers[name];
            }

            var serviceId = FLY.Weight.OBJ_INTERFACE.OBJ_INTERFACE.WEIGHTS_OBJ_MIX_ID(baseId, index);

            var buffer = new BufferServiceClient<Lc_Mix>(serviceId, ConnName);

            buffers.Add(name,buffer);

            return buffer;
        }
        public IBuffer<Lc_Mix> GetRollMix(int index) 
        {
            string name = $"rollMix{index}";
            if (buffers.ContainsKey(name))
            {
                return buffers[name];
            }

            var serviceId = FLY.Weight.OBJ_INTERFACE.OBJ_INTERFACE.WEIGHTS_OBJ_ROLLMIX_ID(baseId, index);

            var buffer = new BufferServiceClient<Lc_Mix>(serviceId, ConnName);

            buffers.Add(name, buffer);

            return buffer;
        }
    }
}
