﻿using FLY.OBJComponents.Client;
using FLY.Winder.Client;
using FLY.Winder.IService;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Unity;

namespace FLY.Winder.UI.Client.UiModule
{
    /// <summary>
    /// CenterWinder.xaml 的交互逻辑
    /// </summary>
    public partial class CenterWinderPanel : UserControl
    {
        IWinderSystemService winderSystem;

        SetPLCUpdatePlan[] setPlan_winders = new SetPLCUpdatePlan[2];

        public CenterWinderPanel()
        {
            InitializeComponent();
        }
        [InjectionMethod]
        public void Init(IWinderSystemService winderSystem)
        {
            this.winderSystem = winderSystem;
            this.DataContext = winderSystem;;
            
            //注册属性更新计划
            for (int i = 0; i < 2; i++)
            {
                setPlan_winders[i] = new SetPLCUpdatePlan(
                    winderSystem.PLCos,
                    winderSystem.Items[i],
                    new string[] {
                        "CenterTensionSet",
                        "CenterInitDia",
                        "IsCenterInitDiaNotify",
                        "CenterTaperSet",
                        "CenterTensionKg",
                        "CenterDia",
                        "EPInitPressure",
                        "EPTaperSet",
                        "EPAirPressure",
                        "IsEPRollerClosed",
                        "IsSurfaceWindGet",
                        "IsCenterWindGet",
                        "IsCsWindGet"
                    });
            }
            winderSystem.Items[0].PropertyChanged += Items0_PropertyChanged;
            winderSystem.Items[1].PropertyChanged += Items1_PropertyChanged;

        }

        private async void Items0_PropertyChanged(object sender, System.ComponentModel.PropertyChangedEventArgs e)
        {
            if (e.PropertyName == "CenterInitDia")
            {
                if (winderSystem is WinderSystemServiceClient) 
                {
                    if ((winderSystem as WinderSystemServiceClient).IsInPushValue)
                        return;
                }

                await Task.Delay(1000);//1s后触发通知
                winderSystem.Items[0].IsCenterInitDiaNotify = true;
            }
        }
        private async void Items1_PropertyChanged(object sender, System.ComponentModel.PropertyChangedEventArgs e)
        {
            if (e.PropertyName == "CenterInitDia")
            {
                if (winderSystem is WinderSystemServiceClient)
                {
                    if ((winderSystem as WinderSystemServiceClient).IsInPushValue)
                        return;
                }

                await Task.Delay(1000);//1s后触发通知
                winderSystem.Items[1].IsCenterInitDiaNotify = true;
            }
        }
        private void UserControl_Unloaded(object sender, RoutedEventArgs e)
        {

        }
    }
}
