﻿
using Misc;
using System.ComponentModel;

namespace FLY.Winder.Common
{
    public class WinderInsideOutside : INotifyPropertyChanged
    {

        #region 辅助代码生成
        /// <summary>
        /// 收卷实际m
        /// </summary>
        [Description("收卷实际m")]
        public float MeasureLen{ get; set; }

        /// <summary>
        /// 收卷设定m
        /// </summary>
        [Description("收卷设定m")]
        public float MeasureLenSet{ get; set; }

        /// <summary>
        /// 收卷预警m
        /// </summary>
        [Description("收卷预警m")]
        public float MeasurePreWarning{ get; set; }

        /// <summary>
        /// 收卷计量关
        /// </summary>
        [Description("收卷计量关")]
        public bool MeasureStop{ get; set; }

        /// <summary>
        /// 收卷计量清零(┷）
        /// </summary>
        [Description("收卷计量清零(┷）")]
        public bool MeasureReset{ get; set; }

        /// <summary>
        /// 收卷翻转点动(┷）
        /// </summary>
        [Description("收卷翻转点动(┷）")]
        public bool TurnoverInching{ get; set; }

        /// <summary>
        /// 收卷切膜飞刀(┷）
        /// </summary>
        [Description("收卷切膜飞刀(┷）")]
        public bool CuttingFilm{ get; set; }

        /// <summary>
        /// 收卷翻转原点(┷）
        /// </summary>
        [Description("收卷翻转原点(┷）")]
        public bool TurnoverOrg{ get; set; }

        /// <summary>
        /// 收卷压臂平移(┷）
        /// </summary>
        [Description("收卷压臂平移(┷）")]
        public bool PressureArmOffset{ get; set; }

        /// <summary>
        /// 顶杆(┷）
        /// </summary>
        [Description("顶杆(┷）")]
        public bool PushRod{ get; set; }

        /// <summary>
        /// 抓手自动
        /// </summary>
        [Description("抓手自动")]
        public bool IsTongAuto{ get; set; }

        /// <summary>
        /// 抓手夹紧(┷）
        /// </summary>
        [Description("抓手夹紧(┷）")]
        public bool TongClamp{ get; set; }

        /// <summary>
        /// 抓手松开(┷）
        /// </summary>
        [Description("抓手松开(┷）")]
        public bool TongLoosen{ get; set; }

        /// <summary>
        /// 抓手上升(┷）
        /// </summary>
        [Description("抓手上升(┷）")]
        public bool TongUp{ get; set; }

        /// <summary>
        /// 抓手下降(┷）
        /// </summary>
        [Description("抓手下降(┷）")]
        public bool TongDown{ get; set; }

        /// <summary>
        /// 抓手进(┷）
        /// </summary>
        [Description("抓手进(┷）")]
        public bool TongIn{ get; set; }

        /// <summary>
        /// 抓手出(┷）
        /// </summary>
        [Description("抓手出(┷）")]
        public bool TongOut{ get; set; }

        /// <summary>
        /// 收卷翻转上位等待(s)
        /// </summary>
        [Description("收卷翻转上位等待(s)")]
        public float TurnoverUpperWait{ get; set; }

        /// <summary>
        /// 收卷翻转原点延时(s)
        /// </summary>
        [Description("收卷翻转原点延时(s)")]
        public float TurnoverOrgDelay{ get; set; }

        /// <summary>
        /// 收卷翻转返回延时(s)
        /// </summary>
        [Description("收卷翻转返回延时(s)")]
        public float TurnoverBackDelay{ get; set; }

        /// <summary>
        /// 收卷锯齿切膜延时(s)
        /// </summary>
        [Description("收卷锯齿切膜延时(s)")]
        public float CuttingFilmDelay{ get; set; }

        /// <summary>
        /// 收卷锯齿切膜时间(s)
        /// </summary>
        [Description("收卷锯齿切膜时间(s)")]
        public float CuttingFilmElapsed{ get; set; }

        /// <summary>
        /// 收卷压臂返回时间(s)
        /// </summary>
        [Description("收卷压臂返回时间(s)")]
        public float PressureArmBackElapsed{ get; set; }

        /// <summary>
        /// 收卷气涨轴检测报警(s)
        /// </summary>
        [Description("收卷气涨轴检测报警(s)")]
        public float AirRollerCheck{ get; set; }

        /// <summary>
        /// 收卷一次平移时间(s)
        /// </summary>
        [Description("收卷一次平移时间(s)")]
        public float OffsetElapsed{ get; set; }

        /// <summary>
        /// 收卷平移停顿时间(s)
        /// </summary>
        [Description("收卷平移停顿时间(s)")]
        public float ElapsedWait{ get; set; }

        /// <summary>
        /// 收卷接料限幅
        /// </summary>
        [Description("收卷接料限幅")]
        public float TapeLimit{ get; set; }

        /// <summary>
        /// 收卷设定张力(kg)
        /// </summary>
        [Description("收卷设定张力(kg)")]
        public float TensionKgSet{ get; set; }

        /// <summary>
        /// 收卷实际张力(kg)
        /// </summary>
        [Description("收卷实际张力(kg)")]
        public float TensionKg{ get; set; }

        /// <summary>
        /// 收卷电机电流(A)
        /// </summary>
        [Description("收卷电机电流(A)")]
        public float Current{ get; set; }

        /// <summary>
        /// 收卷手动
        /// </summary>
        [Description("收卷手动")]
        public bool IsManual{ get; set; }

        /// <summary>
        /// 收卷开启显示
        /// </summary>
        [Description("收卷开启显示")]
        public bool IsOn{ get; set; }

        /// <summary>
        /// 收卷开启设置
        /// </summary>
        [Description("收卷开启设置")]
        public bool IsOnSet{ get; set; }

        /// <summary>
        /// 收卷张力反馈
        /// </summary>
        [Description("收卷张力反馈")]
        public float Tension{ get; set; }

        /// <summary>
        /// 收卷张力设定
        /// </summary>
        [Description("收卷张力设定")]
        public float TensionSet{ get; set; }

        /// <summary>
        /// 收卷增益设定
        /// </summary>
        [Description("收卷增益设定")]
        public float Gain{ get; set; }

        /// <summary>
        /// 收卷积分时间
        /// </summary>
        [Description("收卷积分时间")]
        public float ITime{ get; set; }

        /// <summary>
        /// 收卷调节系数
        /// </summary>
        [Description("收卷调节系数")]
        public float Factor{ get; set; }

        /// <summary>
        /// 收卷辊筒直径
        /// </summary>
        [Description("收卷辊筒直径")]
        public float RollerD{ get; set; }

        /// <summary>
        /// 收卷传动速比
        /// </summary>
        [Description("收卷传动速比")]
        public float GearRatio{ get; set; }

        /// <summary>
        /// 收卷PID结果
        /// </summary>
        [Description("收卷PID结果")]
        public float PIDResult{ get; set; }

        /// <summary>
        /// 收卷PID调节
        /// </summary>
        [Description("收卷PID调节")]
        public float PIDAdjust{ get; set; }

        /// <summary>
        /// 收卷同步速度
        /// </summary>
        [Description("收卷同步速度")]
        public float SyncV{ get; set; }

        /// <summary>
        /// 收卷实际速度
        /// </summary>
        [Description("收卷实际速度")]
        public float Velocity{ get; set; }

        /// <summary>
        /// 收卷升降增益
        /// </summary>
        [Description("收卷升降增益")]
        public float LiftGain{ get; set; }

        /// <summary>
        /// 收卷速度补偿
        /// </summary>
        [Description("收卷速度补偿")]
        public float VelocityComp{ get; set; }

        /// <summary>
        /// 中心设定张力(kg) 0~500, {0:F1}
        /// </summary>
        [Description("中心设定张力(kg) 0~500, {0:F1}")]
        public float CenterTensionSet{ get; set; }

        /// <summary>
        /// 中心初始直径(mm) 0~9999 {0:F0}
        /// </summary>
        [Description("中心初始直径(mm) 0~9999 {0:F0}")]
        public float CenterInitDia{ get; set; }

        /// <summary>
        /// 中心初始直径写入后通知
        /// </summary>
        [Description("中心初始直径写入后通知")]
        public bool IsCenterInitDiaNotify{ get; set; }

        /// <summary>
        /// 中心锥度设定(%) 0~2000 {0:F0}
        /// </summary>
        [Description("中心锥度设定(%) 0~2000 {0:F0}")]
        public float CenterTaperSet{ get; set; }

        /// <summary>
        /// 中心实际张力(kg) -99~99 {0:F1}
        /// </summary>
        [Description("中心实际张力(kg) -99~99 {0:F1}")]
        public float CenterTensionKg{ get; set; }

        /// <summary>
        /// 中心实际直径(mm) 0~9999 {0:F0}
        /// </summary>
        [Description("中心实际直径(mm) 0~9999 {0:F0}")]
        public float CenterDia{ get; set; }

        /// <summary>
        /// 压辊EP初始压力(KG) 0~9 {0:F1}
        /// </summary>
        [Description("压辊EP初始压力(KG) 0~9 {0:F1}")]
        public float EPInitPressure{ get; set; }

        /// <summary>
        /// 压辊EP锥度设定(%) 0~1000 {0:F0}
        /// </summary>
        [Description("压辊EP锥度设定(%) 0~1000 {0:F0}")]
        public float EPTaperSet{ get; set; }

        /// <summary>
        /// 压辊EP实际气压(%) -99~99 {0:F1}
        /// </summary>
        [Description("压辊EP实际气压(%) -99~99 {0:F1}")]
        public float EPAirPressure{ get; set; }

        /// <summary>
        /// 收卷压辊分离写(┷）
        /// </summary>
        [Description("收卷压辊分离写(┷）")]
        public bool EPRollerSeparateSet{ get; set; }

        /// <summary>
        /// 收卷压辊闭合读
        /// </summary>
        [Description("收卷压辊闭合读")]
        public bool IsEPRollerClosed{ get; set; }

        /// <summary>
        /// 中心摩擦补偿 0~9999 {0:F0}
        /// </summary>
        [Description("中心摩擦补偿 0~9999 {0:F0}")]
        public float CenterFrictionalComp{ get; set; }

        /// <summary>
        /// 中心电机扭矩 -999~999 {0:F2}
        /// </summary>
        [Description("中心电机扭矩 -999~999 {0:F2}")]
        public float CenterTensionFactor{ get; set; }

        /// <summary>
        /// 中心传动速比 -99~99 {0:F2}
        /// </summary>
        [Description("中心传动速比 -99~99 {0:F2}")]
        public float CenterTransmissionRatio{ get; set; }

        /// <summary>
        /// 中心速度补偿 0~999 {0:F0}
        /// </summary>
        [Description("中心速度补偿 0~999 {0:F0}")]
        public float CenterVelocityComp{ get; set; }

        /// <summary>
        /// 中心压力系数 -9999~9999 {0:F1}
        /// </summary>
        [Description("中心压力系数 -9999~9999 {0:F1}")]
        public float CenterPressureFactor{ get; set; }

        /// <summary>
        /// 中心输出比值
        /// </summary>
        [Description("中心输出比值")]
        public float CenterOutputRatio{ get; set; }

        /// <summary>
        /// 中心实际速度
        /// </summary>
        [Description("中心实际速度")]
        public float CenterVelocity{ get; set; }

        /// <summary>
        /// 中心实际压力
        /// </summary>
        [Description("中心实际压力")]
        public float CenterPressure{ get; set; }

        /// <summary>
        /// 抓手上下检测时间 0~999
        /// </summary>
        [Description("抓手上下检测时间 0~999")]
        public float TongUpDownTime{ get; set; }

        /// <summary>
        /// 抓手进出检测时间 0~999
        /// </summary>
        [Description("抓手进出检测时间 0~999")]
        public float TongInOutTime{ get; set; }

        /// <summary>
        /// 收卷压辊检测时间 0~999
        /// </summary>
        [Description("收卷压辊检测时间 0~999")]
        public float EPRollerTime{ get; set; }

        /// <summary>
        /// 电子尺当前数据
        /// </summary>
        [Description("电子尺当前数据")]
        public float EleRulerValue{ get; set; }

        /// <summary>
        /// 间隙位置数据
        /// </summary>
        [Description("间隙位置数据")]
        public float InterstitialValue{ get; set; }

        /// <summary>
        /// 直径系数
        /// </summary>
        [Description("直径系数")]
        public float DiaFactor{ get; set; }

        /// <summary>
        /// 大直径设定
        /// </summary>
        [Description("大直径设定")]
        public float MaxDiaSet{ get; set; }

        /// <summary>
        /// 大读数设定
        /// </summary>
        [Description("大读数设定")]
        public float MaxValueSet{ get; set; }

        /// <summary>
        /// 小读数设定
        /// </summary>
        [Description("小读数设定")]
        public float MinValueSet{ get; set; }

        /// <summary>
        /// 小直径设定
        /// </summary>
        [Description("小直径设定")]
        public float MinDiaSet{ get; set; }

        /// <summary>
        /// 间隙宽度设定
        /// </summary>
        [Description("间隙宽度设定")]
        public float InterstitialWidth{ get; set; }

        /// <summary>
        /// 间隙补偿气压
        /// </summary>
        [Description("间隙补偿气压")]
        public float InterstitialPressureComp{ get; set; }

        /// <summary>
        /// 收卷张力显示
        /// </summary>
        [Description("收卷张力显示")]
        public float Tension2{ get; set; }

        /// <summary>
        /// 收卷接料补偿长度设定
        /// </summary>
        [Description("收卷接料补偿长度设定")]
        public float SpliceCompLen{ get; set; }

        /// <summary>
        /// 收卷接料补偿开始位置
        /// </summary>
        [Description("收卷接料补偿开始位置")]
        public float SpliceCompBeginPos{ get; set; }

        /// <summary>
        /// 收卷接料补偿终止位置
        /// </summary>
        [Description("收卷接料补偿终止位置")]
        public float SpliceCompEndPos{ get; set; }

        /// <summary>
        /// 张力补偿系数
        /// </summary>
        [Description("张力补偿系数")]
        public float TensionComp{ get; set; }

        /// <summary>
        /// 表面收卷写(┷）
        /// </summary>
        [Description("表面收卷写(┷）")]
        public bool IsSurfaceWindSet{ get; set; }

        /// <summary>
        /// 表面收卷读
        /// </summary>
        [Description("表面收卷读")]
        public bool IsSurfaceWindGet{ get; set; }

        /// <summary>
        /// 中心收卷写(┷）
        /// </summary>
        [Description("中心收卷写(┷）")]
        public bool IsCenterWindSet{ get; set; }

        /// <summary>
        /// 中心收卷读
        /// </summary>
        [Description("中心收卷读")]
        public bool IsCenterWindGet{ get; set; }

        /// <summary>
        /// 中心表面收卷写(┷）
        /// </summary>
        [Description("中心表面收卷写(┷）")]
        public bool IsCsWindSet{ get; set; }

        /// <summary>
        /// 中心表面收卷读
        /// </summary>
        [Description("中心表面收卷读")]
        public bool IsCsWindGet{ get; set; }

        /// <summary>
        /// 收卷变频故障报警
        /// </summary>
        [Description("收卷变频故障报警")]
        [IsError()]
        public bool IsError_VFD{ get; set; }

        /// <summary>
        /// 收卷风机过载报警
        /// </summary>
        [Description("收卷风机过载报警")]
        [IsError()]
        public bool IsError_Fan{ get; set; }

        /// <summary>
        /// 收翻转刀架过载报警
        /// </summary>
        [Description("收翻转刀架过载报警")]
        [IsError()]
        public bool IsError_Turnover{ get; set; }

        /// <summary>
        /// 收卷急停开启！请复位
        /// </summary>
        [Description("收卷急停开启！请复位")]
        [IsError()]
        public bool IsError_Scram{ get; set; }

        /// <summary>
        /// 收卷换卷气涨轴检测未到位报警
        /// </summary>
        [Description("收卷换卷气涨轴检测未到位报警")]
        [IsError()]
        public bool IsError_AirRollerNoReady{ get; set; }

        /// <summary>
        /// 收预警长度报警！请准备换卷
        /// </summary>
        [Description("收预警长度报警！请准备换卷")]
        [IsError()]
        public bool IsError_MeasurePreWarning{ get; set; }

        /// <summary>
        /// 收卷换卷提醒报警
        /// </summary>
        [Description("收卷换卷提醒报警")]
        [IsError()]
        public bool IsError_ChangeRoll{ get; set; }

        /// <summary>
        /// 中心收卷推杆故障
        /// </summary>
        [Description("中心收卷推杆故障")]
        [IsError()]
        public bool IsError_CwPushRod{ get; set; }

        /// <summary>
        /// 收中心伺服报警
        /// </summary>
        [Description("收中心伺服报警")]
        [IsError()]
        public bool IsError_CwServo{ get; set; }

        /// <summary>
        /// 收表面变频通讯报警
        /// </summary>
        [Description("收表面变频通讯报警")]
        [IsError()]
        public bool IsError_SurfaceCommErr{ get; set; }

        /// <summary>
        /// 收中心伺服通讯报警
        /// </summary>
        [Description("收中心伺服通讯报警")]
        [IsError()]
        public bool IsError_CwCommErr{ get; set; }

        /// <summary>
        /// 抓手下检测报警
        /// </summary>
        [Description("抓手下检测报警")]
        [IsError()]
        public bool IsError_TongDown{ get; set; }

        /// <summary>
        /// 抓手上检测报警
        /// </summary>
        [Description("抓手上检测报警")]
        [IsError()]
        public bool IsError_TongUp{ get; set; }

        /// <summary>
        /// 抓手进检测报警
        /// </summary>
        [Description("抓手进检测报警")]
        [IsError()]
        public bool IsError_TongOut{ get; set; }

        /// <summary>
        /// 抓手出检测报警
        /// </summary>
        [Description("抓手出检测报警")]
        [IsError()]
        public bool IsError_TongIn{ get; set; }

        /// <summary>
        /// 收压辊检测报警
        /// </summary>
        [Description("收压辊检测报警")]
        [IsError()]
        public bool IsError_EPRoller{ get; set; }

        /// <summary>
        /// 收平移进检测报警
        /// </summary>
        [Description("收平移进检测报警")]
        [IsError()]
        public bool IsError_MoveIn{ get; set; }

        /// <summary>
        /// 收平移出检测报警
        /// </summary>
        [Description("收平移出检测报警")]
        [IsError()]
        public bool IsError_MoveOut{ get; set; }

        /// <summary>
        /// 收卸料上位检测报警
        /// </summary>
        [Description("收卸料上位检测报警")]
        [IsError()]
        public bool IsError_UnloadUp{ get; set; }

        /// <summary>
        /// 收液压泵电源故障
        /// </summary>
        [Description("收液压泵电源故障")]
        [IsError()]
        public bool IsError_PumpPower{ get; set; }

        #endregion
        public event PropertyChangedEventHandler PropertyChanged;
    }
}
